SystemOrganization addCategory: #MultiDimensionalEnumeration!

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:57'!
multiDimensionalCollect: aBlockContext
	
	^MultiDimensionalCollect new
		domains: self;
		block: aBlockContext;
		run  ! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalDo: aBlockContext 

	^MultiDimensionalDo new
		domains: self;
		block: aBlockContext;
		run.    
! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalSelect: aBlockContext 

	^MultiDimensionalSelect new
		domains: self;
		block: aBlockContext;
		run.    ! !

Error subclass: #MultiDimensionalEnumerationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

Object subclass: #MultiDimensionalEnumeration
	instanceVariableNames: 'block domains'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

MultiDimensionalEnumeration subclass: #MultiDimensionalCollect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:39'!
handleEvaluation: anObject to: anArray index: anInteger args: argsArray

	anArray at: (anInteger+1) put: anObject.! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:33'!
initialAllocation

	^Array new: ((domains collect: #size) reduce: [:a :b| a*b]).! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:53'!
returnWithAllocation: anArray 

	^anArray! !

MultiDimensionalEnumeration subclass: #MultiDimensionalDo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:51'!
handleEvaluation: anObject to: anUndefinedObject index: anInteger args: anArray 
! !

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:49'!
initialAllocation

	^nil! !

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:51'!
returnWithAllocation: anUndefinedObject 

	^domains! !

!MultiDimensionalEnumeration methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:24'!
block: aBlockClosure 

	block := aBlockClosure! !

!MultiDimensionalEnumeration methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:24'!
domains

	^ domains! !

!MultiDimensionalEnumeration methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:24'!
domains: anArray 

	domains := anArray! !

!MultiDimensionalEnumeration methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 21:16'!
run

	| mqr args allocated |
	mqr := MultiQuoAndRem new.
	mqr dividers: (domains collect: #size).
	
	args := Array new: domains size.
	allocated := self initialAllocation.
	
	0 to: ((domains collect: #size) reduce: [:a :b| a*b])-1 do: [:index|
		(mqr indexValue: index) keysAndValuesDo: [:k :v | args at: k put: ((domains at:k) at:v) ].  
		[self handleEvaluation: (block valueWithArguments: args) to: allocated index: index args: args] on: MultiDimensionalEnumerationError do: [:exp| "ignore"].
		].
	^self returnWithAllocation: allocated.! !

MultiDimensionalEnumeration subclass: #MultiDimensionalSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:40'!
handleEvaluation: aBoolean to: aWriteStream index: aSmallInteger args: anArray 

	aBoolean ifTrue: [aWriteStream nextPut: anArray copy].! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:37'!
initialAllocation

	^WriteStream on: Array new.! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:53'!
returnWithAllocation: aWriteStream 

	^aWriteStream contents.! !

TestCase subclass: #MultiDimensionalEnumerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:11'!
testCollect1

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4}.
	collect block: [:x| x*10 ].
	self assert: {10. 20. 30. 40} equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:14'!
testCollect2

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7}.
	collect block: [:x :y | x*10+y].
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:15'!
testCollect3

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	collect block: [:x :y :z| (x*100)+(y*10)+z].
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:18'!
testDo1

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4}.
	tape := OrderedCollection new.
	do block: [:x| tape addLast: x*10 ].
	do run.
	self assert: {10. 20. 30. 40} equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:20'!
testDo2

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7}.
	tape := OrderedCollection new.
	do block: [:x :y | tape addLast: x*10+y].
	do run.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:25'!
testDo3

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	do run.
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:00'!
testDoReturnsDomains

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	self assert: do domains equals: do run.! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:20'!
testSelect1

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4}.
	select block: [:x| (x rem: 3) = 0 ].
	self assert: {{3}} equals: select run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:22'!
testSelect2

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4. 2 to: 7}.
	select block: [:x :y | (x+y rem: 3) = 0 ].
	self assert: {{1 . 2}. {1 . 5}. {2 . 4}. {2 . 7}. {3. 3}. {3 . 6}. {4 . 2}. {4 . 5}} equals: select run.    ! !
